<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006-2012 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;
if( !$this->CheckPermission('Modify Company Directory') ) return;

$this->SetCurrentTab('companies');

if( isset($params['bulk_submit']) ) {
  if( !isset($params['bulk']) || !is_array($params['bulk']) || count($params['bulk']) == 0 ) {
    $this->SetError($this->Lang('error_nothingselected'));
    $this->RedirectToTab($id);
  }
  if( !isset($params['bulkaction']) ) {
    $this->SetError($this->Lang('error_missingparam'));
    $this->RedirectToTab($id);
  }
  switch($params['bulkaction']) {
  case 'delete':
    $ndel = 0;
    foreach( $params['bulk'] as $one ) {
      try {
	cd_company::delete((int)$one);
	$ndel++;
      }
      catch( Exception $e ) {
	// ignore
      }
    }
    $this->SetMessage($this->Lang('msg_bulkdel',$ndel));
    break;

  case 'disable':
    foreach( $params['bulk'] as &$one ) {
      $one = (int)$one;
    }
    $db = cmsms()->GetDb();
    $query = 'UPDATE '.cms_db_prefix().'module_compdir_companies SET status = ?
               WHERE id IN ('.implode(',',$params['bulk']).')';
    $dbr = $db->Execute($query,array('disabled'));
    break;

  case 'publish':
    foreach( $params['bulk'] as &$one ) {
      $one = (int)$one;
    }
    $db = cmsms()->GetDb();
    $query = 'UPDATE '.cms_db_prefix().'module_compdir_companies SET status = ?
               WHERE id IN ('.implode(',',$params['bulk']).')';
    $dbr = $db->Execute($query,array('published'));
    break;

  default:
    $this->SetError($this->Lang('error_missingparam'));
    break;
  }
}
$this->RedirectToTab($id);

#
# EOF
#
