<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;
if( !$this->CheckPermission('Modify Site Preferences') ) exit;

if( isset($params['submit']) )
  {
    $this->SetPreference('url_required',(int)$params['url_required']);
    $this->SetPreference('url_autocreate',(int)$params['url_autocreate']);
    $this->SetPreference('url_createoncopy',(int)$params['url_createoncopy']);
    $this->SetPreference('url_redirectold',(int)$params['url_redirectold']);
  }
else if( isset($params['createurls']) )
  {
	$query = 'SELECT id,company_name FROM '.cms_db_prefix().'module_compdir_companies WHERE URL = ?';
	$list = $db->GetArray($query,array(''));
	$num_updated = 0;
	$num_errors = 0;
	if( is_array($list) )
	  {
		foreach( $list as $one )
		  {
			$url = cd_utils::generate_url($one['company_name']);
			if( !$url )
			  {
				$num_errors++;
				continue;
			  }
			if( !cd_utils::validate_url($url) )
			  {
				$num_errors++;
				continue;
			  }

			$query = 'UPDATE '.cms_db_prefix().'module_compdir_companies SET url = ? WHERE id = ?';
			$dbr = $db->Execute($query,array($url,$one['id']));
			if( !$dbr )
			  {
				$num_errors++;
				continue;
			  }

			$num_updated++;
		  }
	  }

	if( $num_updated )
	  {
		$this->SetMessage($this->Lang('info_batchurlcreate',$num_updated));
	  }
	if( $num_errors )
	  {
		$this->SetError($this->Lang('error_batchurlcreate',$num_errors));
	  }
  }


$this->RedirectToTab($id,'urls','','admin_settings');
#
# EOF
#
?>