<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if (!isset($gCms)) exit;

$thetemplate = 'categorylist_'.$this->GetPreference(COMPANYDIR_PREF_DFLTCATEGORYLIST_TEMPLATE);
if( isset($params['categorylisttemplate'] ) ) {
  $thetemplate = 'categorylist_'.$params['categorylisttemplate'];
}

$query = '';
if( isset($params['showall']) )
  {
    $query = 'SELECT a.*, bb.count 
              FROM '.cms_db_prefix().'module_compdir_categories a 
              LEFT OUTER JOIN 
               (SELECT a.category_id,count(b.id) AS count 
                FROM '.cms_db_prefix().'module_compdir_company_categories a 
                LEFT OUTER JOIN '.cms_db_prefix().'module_compdir_companies b ON a.company_id = b.id 
                 WHERE b.status = \'published\' 
                GROUP by a.category_id) bb 
              ON a.id = bb.category_id ORDER BY a.name ASC';
}
else {
  $subquery = '';
  if( isset($params['categoryid']) ) {
	$suqbquery = 'SELECT company_id FROM '.cms_db_prefix().'module_compdir_company_categories WHERE category_id = '.(int)$params['categoryid'];
  }
  else if( isset($params['category']) ) {
	$ids = cd_company_query::get_category_ids($params['category']);
	if( is_array($ids) && count($ids) ) {
	  $subquery = 'SELECT DISTINCT company_id FROM '.cms_db_prefix().'module_compdir_company_categories WHERE category_id IN ('.implode(',',$ids).')';
	}
  }
  else if( isset($params['hier']) ) {
	$hierarchy = html_entity_decode(trim($params['hier']));
	$hierarchy = trim($hierarchy);
	$hierarchy = trim(str_replace("'",'_',$hierarchy));

	if( strpos($hierarchy,'|') !== FALSE || strpos($hierarchy,'*') !== FALSE ) {
	  $hierarchy = trim(str_replace('*','%',$hierarchy));
	  $subquery = 'SELECT DISTINCT CO.id FROM '.cms_db_prefix().'module_compdir_companies CO 
                   LEFT OUTER JOIN '.cms_db_prefix().'module_compdir_hier CH
                     ON CH.id = CO.hier_id 
                   WHERE upper(CH.long_name) LIKE upper('.$db->qstr($hierarchy).')';
	}
	else {
	  $subquery = 'SELECT DISTINCT CO.id FROM '.cms_db_prefix().'module_compdir_companies CO 
                   LEFT OUTER JOIN '.cms_db_prefix().'module_compdir_hier CH
                   ON CH.id = CO.hier_id 
                   WHERE CH.name = '.$db->qstr($hierarchy);
	}
  }

  $query = 'SELECT C.*,count(BB.id) AS count 
            FROM '.cms_db_prefix().'module_compdir_company_categories A 
            LEFT JOIN '.cms_db_prefix().'module_compdir_companies BB 
            ON A.company_id = BB.id AND BB.status = \'published\'';
  if( $subquery ) $query .= ' AND BB.id IN ('.$subquery.")\n";;
  $query .= ' LEFT JOIN '.cms_db_prefix().'module_compdir_categories C ON C.id = A.category_id'; 
  $query .= ' GROUP BY A.category_id ORDER BY C.name ASC';
}
$dbresult = $db->Execute( $query );

$results = array();
$detailpage = $returnid;
//$urlfmt = "companies/bycategory/%d/".($detailpage!=''?$detailpage:$returnid);
$urlfmt = "companies/bycategory/%d/".$returnid;
$config = cmsms()->GetConfig();
while( $dbresult && $row = $dbresult->FetchRow() ) {
  $obj = new StdClass();
  foreach( $row as $k => $v ) {
	$obj->$k = $v;
  }
  if( is_null($obj->count) ) $obj->count = 0;
  if( $obj->image ) {
	$path = cms_join_path($config['uploads_path'],'companydirectory','cat'.$obj->id);
	if( file_exists(cms_join_path($path,$obj->image)) ) {
	  $obj->image_url = $config['uploads_url']."/companydirectory/cat{$obj->id}/{$obj->image}";
	  if( file_exists(cms_join_path($path,'thumb_'.$obj->image)) ) {
		$obj->thumb_url = $config['uploads_url']."/companydirectory/cat{$obj->id}/thumb_{$obj->image}";
	  }
	}
  }

  {
	// an un-pretty version of the summary url.   This will pass down the parameters passed in (like the hier)
	$parms2 = $params;
	unset($parms2['categoryid']);
	if( isset($parms2['category']) ) $parms2['category2'] = $row['name']; // already have a category, have to use category2

	$obj->stdsummary_url = $this->CreateLink($id,'default',($detailpage!=''?$detailpage:$returnid),
											 '',$parms2,'',true,true,'');
  }

  {
	// the old, standard, pretty url (by category).
	$params3 = $params;
	if( isset($params3['category']) ) unset($params3['category']);
	$params3['categoryid']=$row['id'];
	$prettyurl = sprintf($urlfmt,$row['id']);
	$obj->summary_url = $this->CreateLink($id,'default',($detailpage!=''?$detailpage:$returnid),
										  '',$params3,
										  '',true,true,'',true);
  }

  $results[] = $obj;
}
if( $dbresult ) $dbresult->Close();

$smarty->assign('categorylist',$results);

echo $this->ProcessTemplateFromDatabase($thetemplate);
// EOF
?>
