<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

if (!isset($gCms)) exit;

$catid = '';
if (isset($params['catid']))
{
	$catid = $params['catid'];
}

// Get the category details
$query = 'SELECT * FROM '.cms_db_prefix().'module_compdir_categories WHERE id = ?';
$row = $db->GetRow($query, array( $catid));

//Now remove the category
$query = "DELETE FROM ".cms_db_prefix()."module_compdir_categories WHERE id = ?";
$db->Execute($query, array($catid));

$query = 'UPDATE '.cms_db_prefix().'module_compdir_categories SET iorder = iorder - 1 WHERE iorder > ?';
$db->Execute($query,array($row['iorder']));

// and it's images and attachments
$config =cmsms()->GetConfig();
$catdir = cms_join_path($config['uploads_path'],'companydirectory','cat'.$catid);
cge_dir::recursive_rmdir($catdir);

//And remove it from any entries
$query = "DELETE FROM module_compdir_company_categories WHERE category_id = ?";
$db->Execute($query, array($catid));

audit($catid,$this->GetName(),'Deleted Category');
$params = array('tab_message'=> 'categorydeleted', 'active_tab' => 'categories');
$this->Redirect($id, 'admin_settings', $returnid, $params);

?>