<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;

#
# Cached data
#
$_hier_cache = null;
$_fielddef_cache = null;
$_category_cache = null;
$_error = '';
$_num_hier = 0;
set_time_limit(9999);

#
# Initialization
#
$delimiter = '';
$do_lookup = 0;

#
# Get Form Data
#
$importer = new cd_ascii_importer($this);
if( isset($params['cancel']) )
  {
    $this->CGRedirect($id,'defaultadmin',$returnid);
  }
if( isset($params['delimeter']) )
  {
    $delimeter = trim($params['delimeter']);
    $importer->set_delimiter($delimeter);
    $this->SetPreference('import_delimiter',$delimeter);
  }
if( isset($params['do_fielddefs']) )
  {
    $do_fielddefs = (int)trim($params['do_fielddefs']);
    $importer->do_fielddefs($do_fielddefs);
    $this->SetPreference('import_fielddefs',$do_fielddefs);
  }
if( isset($params['do_fieldvals']) )
  {
    $do_fieldvals = (int)trim($params['do_fieldvals']);
    $importer->do_fieldvals($do_fieldvals);
    $this->SetPreference('import_fieldvals',$do_fieldvals);
  }
if( isset($params['do_categorydefs']) )
  {
    $do_categorydefs = (int)trim($params['do_categorydefs']);
    $importer->do_categorydefs($do_categorydefs);
    $this->SetPreference('import_categorydefs',$do_categorydefs);
  }
if( isset($params['do_hierarchydefs']) )
  {
    $do_hierarchydefs = (int)trim($params['do_hierarchydefs']);
    $importer->do_hierarchydefs($do_hierarchydefs);
    $this->SetPreference('import_hierarchydefs',$do_hierarchydefs);
  }
if( isset($params['do_hierarchyvals']) )
  {
    $do_hierarchyvals = (int)trim($params['do_hierarchyvals']);
    $importer->do_hierarchyvals($do_hierarchyvals);
    $this->SetPreference('import_hierarchyvals',$do_hierarchyvals);
  }
if( isset($params['do_categoryvals']) )
  {
    $do_categoryvals = (int)trim($params['do_categoryvals']);
    $importer->do_categoryvals($do_categoryvals);
    $this->SetPreference('import_categoryvals',$do_categoryvals);
  }
if( isset($params['categorycolumn']) )
  {
	$categorycolumn = trim($params['categorycolumn']);
	$importer->set_categorycolumn($categorycolumn);
	$this->SetPreference('import_categorycolumn',$categorycolumn);
  }
if( isset($params['do_lookup']) )
  {
    $do_lookup = (int)trim($params['do_lookup']);
    $importer->do_latlong_lookup($do_lookup);
    $this->SetPreference('import_lookuplatlong',$do_lookup);
  }
$create_url = 0;
if( isset($params['create_url']) )
  {
    $create_url = (int)trim($params['create_url']);
    $this->SetPreference('import_create_url',$do_lookup);
  }
$importer->create_url($create_url || $this->GetPreference('url_required',0));

if( isset($params['check_duplicates']) )
  {
    $check_duplicates = trim($params['check_duplicates']);
    $importer->check_duplicate_companies($check_duplicates);
    $this->SetPreference('import_checkduplicates',$check_duplicates);
  }

if( $delimeter == '' )
  {
    $this->SetError($this->Lang('error_missingparam'));
    $this->CGRedirect($id,'importcsv',$returnid);
  }
else if( !isset($_FILES[$id.'csvfile']) || $_FILES[$id.'csvfile']['size'] == 0 )
  {
    $this->SetError($this->Lang('error_missingupload'));
    $this->CGRedirect($id,'importcsv',$returnid);
  }
else if( $_FILES[$id.'csvfile']['error'] != 0 )
  {
    $this->SetError($this->Lang('error_badupload'));
    $this->CGRedirect($id,'importcsv',$returnid);
  }
$filename = $_FILES[$id.'csvfile']['tmp_name'];

$res = $importer->import_file($filename);
$errors = $importer->get_errors();
if( count($errors) )
  {
    $smarty->assign('errors',$errors);
  }
$results = $importer->get_results();
$smarty->assign('num_companies',$results['num_companies']);
$smarty->assign('num_categories',$results['num_categories']);
$smarty->assign('num_fielddefs',$results['num_fielddefs']);
$smarty->assign('num_hier',$results['num_hier']);
$smarty->assign('return_url',$this->CreateURL($id,'defaultadmin',$returnid));

if( $results['num_companies'] > 0 || $results['num_categories'] > 0 || 
	$results['num_fielddefs'] > 0 || $results['num_hier'] > 0 )
  {
	audit('',$this->GetName(),
		  sprintf('Imported data from CSV (%d companies, %d categories, %d field defs, %d hier)',
				  $results['num_companies'], $results['num_categories'], 
				  $results['num_fielddefs'], $results['num_hier']));
  }

echo $this->ProcessTemplate('do_importcsv.tpl');
#
# EOF
#
?>
