<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if (!isset($gCms)) exit;

#
# Initialization
#
$country = 'US';
$address = '';
$have_latlong = 0;
$latitude = '';
$longitude = '';
$postal = '';
$radius = '50';
$units  = 'miles';
$company_name = '';
$name_type = 'exact';
$use_categories = '';
$errors = array();
$base_lat = '';
$base_long = '';
$postcode = cge_utils::get_module('Postcode');
$do_zip_search = 0;
$postal_data = '';
$bounding_box = '';
$sortorder = $this->GetPreference('sortorder','asc');
$sortby = $this->GetPreference('sortby','company_name');
$detailpage = $returnid;
$inline = 0;
$page = 1;
$pagelimit = 100000;
$count = 0;
$numpages = 0;
$summarytemplate = $this->GetPreference(COMPANYDIR_PREF_DFLTSUMMARY_TEMPLATE);
//$urlfmt = 'companies/%d/'.($detailpage!=''?$detailpage:$returnid);
$entryarray = array();
$config = $gCms->GetConfig();
$stored_categories = '';
$hierarchy = '';
$search_address = 0;
$postal_chars = '';
$inline = 0;

#
# Setup
#
$tmp = $this->GetPreference('detailpage',-1);
if( $tmp > 0 ) $detailpage = $tmp;
if( isset( $params['page'] ) ) $page = (int)$params['page'];
if( isset( $params['pagelimit'] ) ) $pagelimit = (int)$params['pagelimit'];
if( isset( $params['inline'] ) && $params['inline'] != 0 ) $inline = 1;
if( isset( $params['detailpage'] ) ) {
  $tmp = $this->resolve_alias_or_id($params['detailpage']);
  if( $tmp ) {
	$detailpage = $tmp;
	$inline = 0;
  }
}
if( isset($params['searchaddress']) && $params['searchaddress'] ) $search_address = 1;
if( isset($params['postalchars']) && $params['postalchars'] ) $postal_chars = (int)$params['postalchars'];
if( isset( $params['sortorder'] ) ) {
  switch( $params['sortorder'] ) {
  case 'asc':
  case 'desc':
	$sortorder = $params['sortorder'];
  }
}
if( isset( $params['sortby'] ) ) {
  switch( $params['sortby'] ) {
  case 'company_name':
	$sortby = 'company_name';
	break;
  case 'phone':
	$sortby = 'telephone';
	break;
  case 'fax':
	$sortby = 'fax';
	break;
  case 'email':
	$sortby = 'contact_email';
	break;
  case 'website':
	$sortby = 'website';
	break;
  case 'created':
	$sortby = 'create_date';
	break;
  case 'modified':
	$sortby = 'modified_date';
	break;
  case 'status':
	$sortby = 'status';
	break;
  case 'random':
	$sortby = 'RAND()';
	$sortorder = '';
	break;
  case 'distance':
	$sortby = 'distance';
	break;
  }
}
if( $sortby == 'random' ) {
  $sortby = 'RAND()';
  $sortorder = '';
}
if( isset($params['summarytemplate'] ) ) $summarytemplate = $params['summarytemplate'];
if( isset($params['hier']) ) $hierarchy = trim($params['hier']);
if( isset($params['cd_stored_categories']) ) $stored_categories = explode(',',$params['cd_stored_categories']);


#
# Handle form submission
#
if( isset($params['cd_cancel']) ) {
  $destpage = $returnid;
  if( isset($params['cd_origpage']) ) $destpage = (int)$params['cd_origpage'];
  $this->RedirectContent($destpage);
}
else if( isset($params['cd_submit']) || isset($params['cd_dosearch']) ) {
  //
  // get the data
  //
  if( isset($params['cd_country']) && !empty($params['cd_country']) ) {
	$country = trim($params['cd_country']);
  }
  if( isset($params['cd_postal']) && !empty($params['cd_postal']) ) {
	$postal = trim($params['cd_postal']);
	$do_zip_search = 1;
  }
  if( isset($params['cd_latitude']) && isset($params['cd_longitude']) &&
	  !empty($params['cd_latitude']) && !empty($params['cd_longitude']) ) {
	$have_latlong = 1;
	$latitude = (float)floatval($params['cd_latitude']);
	$longitude = (float)floatval($params['cd_longitude']);
  }
  if( isset($params['cd_address']) && !empty($params['cd_address']) ) {
	$address = trim($params['cd_address']);
  }
  if( isset($params['cd_radius']) && !empty($params['cd_radius']) ) {
	$radius = (int)$params['cd_radius'];
  }
  if( isset($params['cd_units']) && !empty($params['cd_units']) ) {
	$units = strtolower(trim($params['cd_units']));
  }
  if( isset( $params['cd_inline'] ) && $params['cd_inline'] != 0 ) {
	$inline = 1;
	$params['inline'] = $inline;
  }
  if( isset($params['cd_name']) && $params['cd_name'] != '' ) {
	$company_name = trim($params['cd_name']);
  }
  if( isset($params['cd_name_type']) && $params['cd_name_type'] != '' ) {
	$name_type = strtolower(trim($params['cd_name_type']));
  }
  if( $hierarchy == '' && isset($params['cd_hier']) && $params['cd_hier'] != '' ) {
	if( $params['cd_hier'] != '' && $params['cd_hier'] != '-1' ) {
	  $hierarchy = trim($params['cd_hier']);
	  if( isset($params['cd_hier_children']) && (int)$params['cd_hier_children'] != 0 ) {
		// we're including children.
		$hierarchy .= '*';
	  }
	}
  }
  if( isset($params['cd_use_categories']) ) {
	$tmp = $params['cd_use_categories'];
	if( is_array($tmp) && count($tmp) ) {
	  $use_categories = $tmp;
	  $params['cd_stored_categories'] = implode(',',$use_categories);
	  unset($params['cd_use_categories']);
	}
	else if( $tmp != '' ) {
	  $use_categories = array($tmp);
	  $params['cd_stored_categories'] = $tmp;
	  unset($params['cd_use_categories']);
	}
  }
  else if (isset($params['cd_dosearch'])) {
	// comping from a link
	$use_categories = $stored_categories;
  }
  if( isset($params['cd_submit']) ) {
	unset($params['cd_submit']);
	$params['cd_dosearch'] = 1;
  }

  //
  // validate the data
  //
  if( $units != 'miles' && $units != 'km' ) {
	// invalid units
	$errors[] = $this->Lang('error_invalid_param','cd_units');
  }
  if( $radius <= 0 ) {
	// invalid units
	$errors[] = $this->Lang('error_invalid_param','cd_radius');
  }
  if( $do_zip_search && $postcode ) {
	if( $country== '' ) $errors[] = $this->Lang('error_invalid_param','cd_country');
  }
  if( $name_type != 'exact' && $name_type != 'like') {
	// invalid units
	$errors[] = $this->Lang('error_invalid_param','cd_name_type');
  }
	
  // convert distance to miles
  if( empty($errors) && $units == 'km' ) $radius = (float)$radius * 0.621371192;

  // if we can find the Postcode module now we can find a base latitude and longitude.
  if( empty($errors) && !$have_latlong && !empty($postal) && $postcode && $do_zip_search  ) {
	$postal_data = $postcode->Lookup_Zip($country,$postal,$postal_chars);
	if( !is_array($postal_data) && !$search_address ) {
	  // it didn't work
	  $errors[] = $this->Lang('error_postcode_lookup',$postal);
	}
	$latitude = $postal_data['latitude'];
	$longitude = $postal_data['longitude'];
	$have_latlong = 1;
  }

  if( empty($errors) && !$have_latlong && !empty($address)) {
	// we don't have a bounding box yet, maybe we can do a lat/long lookup from the address and get one.
	$coords = cd_utils::geolocate($address);
	if( $coords !== false ) {
	  $latitude = $coords['lat'];
	  $longitude = $coords['lon'];
	  $have_latlong = 1;
	}
  }

  // were we given a latitude and longitude?
  if( empty($errors) && $have_latlong ) $bounding_box = $this->GetBoundingBox($latitude,$longitude,$radius);

  //
  // build the query
  //
  if( empty($errors) ) {
	$qparms1 = array();
	$qparms2 = array();
	$where = array();
	$query = '';

	if( is_array($bounding_box) ) {
	  // calculate a distance for us too.
	  $query .= 'SELECT c.*,( 3959 * acos( cos( radians(?) ) 
                 * cos( radians( c.latitude ) ) 
                 * cos( radians( c.longitude ) - radians(?) ) 
                 + sin( radians(?) ) 
                 * sin( radians( c.latitude ) ) ) ) AS distance
                 FROM '.cms_db_prefix().'module_compdir_companies c';
	  $qparms1[] = $latitude;
	  $qparms1[] = $longitude;
	  $qparms1[] = $latitude;
	}
	else {
	  $query = 'SELECT c.* FROM '.cms_db_prefix().'module_compdir_companies c';
	}
	$query2 = 'SELECT count(*) AS count FROM '.cms_db_prefix().'module_compdir_companies c';

	$where[] = '(c.status = ?)';
	$qparms1[] = 'published';
	$qparms2[] = 'published';

	if( $search_address && !empty($postal) ) {
	  $tpostal = $postal;
	  if( $postal_chars > 0 ) $tpostal = substr($postal,0,$postal_chars);

	  // searching addresses
	  $tmp = array();
	  $tmp[] = '(c.address LIKE ?)';
	  $qparms1[] = '%'.$tpostal.'%';
	  $qparms2[] = '%'.$tpostal.'%';

	  if( is_array($bounding_box) ) {
		$tmp[] = '(c.latitude BETWEEN ? AND ?) AND (c.longitude BETWEEN ? AND ?)';
		$qparms1[] = $bounding_box[0];
		$qparms1[] = $bounding_box[1];
		$qparms1[] = $bounding_box[2];
		$qparms1[] = $bounding_box[3];
		$qparms2[] = $bounding_box[0];
		$qparms2[] = $bounding_box[1];
		$qparms2[] = $bounding_box[2];
		$qparms2[] = $bounding_box[3];
	  }

	  $where[] = '(' . implode(' OR ',$tmp) .')';
	}
	else {
	  if( is_array($bounding_box) ) {
		$where[] = '(c.latitude BETWEEN ? AND ?) AND (c.longitude BETWEEN ? AND ?)';
		$qparms1[] = $bounding_box[0];
		$qparms1[] = $bounding_box[1];
		$qparms1[] = $bounding_box[2];
		$qparms1[] = $bounding_box[3];
		$qparms2[] = $bounding_box[0];
		$qparms2[] = $bounding_box[1];
		$qparms2[] = $bounding_box[2];
		$qparms2[] = $bounding_box[3];
	  }
	}
	if( !empty($company_name) ) {
	  switch( $name_type ) {
	  case 'exact':
		$where[] = '(c.company_name = ?)';
		$qparms1[] = $company_name;
		$qparms2[] = $company_name;
		break;
	  case 'like':
		$qparms1[] = '%'.$company_name.'%';
		$qparms2[] = '%'.$company_name.'%';
		$where[] = '(c.company_name LIKE ?)';
	  }
	}
	if( $hierarchy != '' ) {
	  // doing hierarchy search.
	  $str = ' LEFT OUTER JOIN '.cms_db_prefix().'module_compdir_hier ch ON ch.id = c.hier_id';
	  $query .= $str;
	  $query2 .= $str;
	  $hierarchy = cms_html_entity_decode(trim($hierarchy));
	  $hierarchy = trim($hierarchy);
	  $hierarchy = trim(str_replace("'",'_',$hierarchy));
	  if (strpos($hierarchy, '|') !== FALSE || strpos($hierarchy, '*') !== FALSE) {
		// wildcards
		$hierarchy = trim(str_replace('*','%',$hierarchy));
		$where[] = "upper(ch.long_name) LIKE upper(?)";
	  }
	  else {
		// hard coded hierarchy name
		$where[] = 'ch.name = ?';
	  }
	  $qparms1[] = $hierarchy;
	  $qparms2[] = $hierarchy;
	}
	if( is_array($use_categories) && count($use_categories) ) {
	  $str = " INNER JOIN ".cms_db_prefix()."module_compdir_company_categories cc ON cc.company_id = c.id";
	  $query .= $str;
	  $query2 .= $str;
	  $where[] = 'cc.category_id IN ('.implode(',',$use_categories).')';
	}

	//
	// assembly
	//
	if( count($where) ) {
	  $query = $query . ' WHERE ' . implode(' AND ',$where );
	  $query2 = $query2 . ' WHERE ' . implode(' AND ',$where );
	}
	$query .= ' ORDER BY '.$sortby.' '.$sortorder;

	//
	// more setup
	//
	$startelement = ($page-1)*$pagelimit;

	//
	// Execution
	//
	$count = $db->GetOne($query2,$qparms2);
	if( $count ) {
	  $dbr = $db->SelectLimit($query,$pagelimit,$startelement,$qparms1);
	  if( !$dbr ) {
		echo 'FATAL ERROR<br/>';
		echo $db->ErrorMsg().'<br/>';
		echo $db->sql;
		return;
	  }

	  // determine number of pages
	  $numpages = (int)($count / $pagelimit);
	  if( $count % $pagelimit != 0 ) $numpages++;

	  //
	  // now build the object list.
	  //
	  $idlist = array();
	  while( $dbr && $row = $dbr->FetchRow() ) {
		$idlist[] = $row['id'];

		$onerow = new stdClass;
		foreach( $row as $key => $value ) {
		  $onerow->$key = $value;
		}
		if( $units == 'miles' && $onerow->distance ) $onerow->distance *= 1/0.621371192;

		$parms = array();
		$parms['companyid'] = $row['id'];
		if( isset($params['detailtemplate']) ) {
		  $parms['detailtemplate'] = $params['detailtemplate'];
		}

		$url = "companies/{$row['id']}/{$returnid}/".munge_string_to_url($row['company_name']);
		$onerow->detail_url = $this->CreateURL($id,'details',$detailpage,$parms,false,$url);
		$onerow->picture_path = $config['root_url'].'/uploads/companydirectory/id'.$row['id'].'/'.$row['picture_location'];
		$onerow->logo_path = $config['root_url'] . '/uploads/companydirectory/id'.$row['id'].'/'.$row['logo_location'];

		// get the custom fields
		$fielddefs = $this->GetFieldDefsForCompany($row['id']);
		$fieldarray = array();
		$onerow->customfieldscount = count($fielddefs);
		$onerow->customfieldsbyname = array();
		if ($onerow->customfieldscount > 0) {
		  foreach ($fielddefs as $fielddef) {
			$field = new stdClass();
			$field->id = $fielddef->id;
			$field->name = $fielddef->name;
			$field->value = $fielddef->value;
			$fieldarray[$field->id] = $field;
			$onerow->customfieldsbyname[$fielddef->name] = $fielddef->value;
		  }
		  $onerow->customfields = $fieldarray;
		}

		$entryarray[] = $onerow;
	  } // while

		// update search stats
	  if( count($idlist) && $this->GetPreference('collectstats',0) ) {
		$now = $db->DbTimeStamp(time());
		$query = 'INSERT INTO '.cms_db_prefix()."module_compdir_searchstats
                    (company_id,date_searched,postcode) VALUES (?,$now,?)";
		foreach( $idlist as $one ) {
		  $db->Execute($query,array($one,$postal));
		}
	  }
	} // count
  } // no errors
} // submit

#
# Give Everything to Smarty
#
if( count($errors) ) $smarty->assign('errors',$errors);
if( count($entryarray) ) {
  $smarty->assign('items',$entryarray);
}
else {
  $smarty->assign('message',$this->Lang('error_noresultsfound'));
}
if( is_array($postal_data) ) $smarty->assign('postal_data',$postal_data);
$smarty->assign('itemcount',count($entryarray));
$smarty->assign('itemcount', count($entryarray));
$smarty->assign('pagetext',$this->Lang('page'));
$smarty->assign('oftext',$this->Lang('of'));
$smarty->assign('pagecount',$numpages);
$smarty->assign('curpage',$page);
if( $numpages ) {
  if( $page == 1) {
	$smarty->assign('firstlink',$this->Lang('firstpage'));
	$smarty->assign('prevlink',$this->Lang('prevpage'));
  }
  else {
	$parms = $params;
	$parms['page'] = 1;
	$smarty->assign('firstlink',$this->CreateLink($id,'default',$returnid,
												  $this->Lang('firstpage'),
												  $parms));
	$parms['page'] = $page - 1;
	$smarty->assign('prevlink',$this->CreateLink($id,'default',$returnid,
												 $this->Lang('prevpage'),
												 $parms));
  }
  if( $page == $numpages ) {
	$smarty->assign('lastlink',$this->Lang('lastpage'));
	$smarty->assign('nextlink',$this->Lang('nextpage'));
  }
  else {
	$parms = $params;
	$parms['page'] = $numpages;
	$smarty->assign('lastlink',$this->CreateLink($id,'default',$returnid,
												 $this->Lang('lastpage'),
												 $parms));
	$parms['page'] = $page + 1;
	$smarty->assign('nextlink',$this->CreateLink($id,'default',$returnid,
												 $this->Lang('nextpage'),
												 $parms));
  }
}

echo $this->ProcessTemplateFromDatabase('summary_'.$summarytemplate);

#
# EOF
# 
?>
