<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

function process_field($txt,$delim = '|')
{
  $txt = trim($txt);
  $txt = str_replace($delim,'-%%-',$txt);
  $txt = str_replace("\r\n","\n",$txt);
  $txt = str_replace("\r","\n",$txt);
  $txt = str_replace("\n",'^^',$txt);
  if( strstr($txt,' ') !== FALSE )
    {
      $txt = '"'.$txt.'"';
    }
  return $txt;
}

$delim = '|';

$query = 'SELECT * FROM '.cms_db_prefix().'module_compdir_fielddefs ORDER BY item_order ASC';
$fielddefs = $db->GetArray($query);

// 1. Build the header line
$header = '#COMPANY=C'.$delim;

// 1.1 Get the companies header.
$query = "SELECT * FROM ".cms_db_prefix()."module_compdir_companies ORDER BY company_name LIMIT 1";
$row = $db->GetRow($query);
unset($row['create_date']);
unset($row['modified_date']);
unset($row['id']);
unset($row['owner_id']);
unset($row['picture_location']);
unset($row['logo_location']);
unset($row['hier_id']);
$row['hierarchy'] = 1;
$company_fields = array_keys($row);
$header .= implode($delim,$company_fields);
$header .= $delim;

// 1.1.1 Get the field definition names
if( $fielddefs && is_array($fielddefs) )
  {
    foreach( $fielddefs as $one )
      {
	if( strstr($one['name'],' ') !== FALSE )
	  {
	    $header .= 'FIELD:"'.trim($one['name']).'"'.$delim;
	  }
	else
	  {
	    $header .= 'FIELD:'.trim($one['name']).$delim;
	  }
      }
    $header = substr($header,0,-1*strlen($delim));
  }

// 1.1.2 Get the category names
$query = 'SELECT name FROM '.cms_db_prefix().'module_compdir_categories ORDER BY iorder ASC'; 
$names = $db->GetArray($query);
if( $names && is_array($names) )
  {
    $header .= $delim;
    foreach( $names as $one )
      {
	if( strstr($one['name'],' ') !== FALSE )
	  {
	    $header .= 'CAT:"'.trim($one['name']).'"'.$delim;
	  }
	else
	  {
	    $header .= 'CAT:'.trim($one['name']).$delim;
	  }
      }
    $header = substr($header,0,-1*strlen($delim));
  }

// 1.2 Get the field definition header
$query = 'SELECT * FROM '.cms_db_prefix().'module_compdir_fielddefs ORDER BY item_order LIMIT 1';
$row = $db->GetRow($query);
if( $row )
  {
    unset($row['id']);
    unset($row['item_order']);
    unset($row['create_date']);
    unset($row['modified_date']);
    $fielddef_fields = array_keys($row);
    $header .= "\n#FIELDDEF=F".$delim.implode($delim,$fielddef_fields);
    //$header = substr($header,0,-1*strlen($delim))."\n";
  }

// 1.3 Get the categories definition header
$header .= "\n#CATEGORY=T".$delim."name\n";

// 1.4 Get the hierarchy definition header
$header .= "#HIERARCHY=H".$delim."long_name\n";

// 2 begin output.
$csv_output = $header."\n";

// 2.1 output the field definitions
foreach( $fielddefs as $row )
  {
    $line = 'F'.$delim;
    foreach( $fielddef_fields as $fn )
      {
	$data = process_field($row[$fn],$delim);
	$line .= $data.$delim;
      }
    $line = substr($line,0,-1*strlen($delim))."\n";
    $csv_output .= $line;
  }

// 2.2 output the categories
$csv_output .= "\n";
$query = 'SELECT DISTINCT name FROM '.cms_db_prefix().'module_compdir_categories ORDER BY iorder ASC';
$dbr = $db->Execute($query);
while( $dbr && $row = $dbr->FetchRow() )
  {
    $line = 'T'.$delim;
    $txt = process_field($row['name'],$delim);
    $line .= $txt.$delim;
    $line = substr($line,0,-1*strlen($delim))."\n";
    $csv_output .= $line;
  }

// 2.3 output the hierarchies
$query = 'SELECT * FROM '.cms_db_prefix().'module_compdir_hier ORDER BY hierarchy';
$dbr = $db->Execute($query);
while( $dbr && $row = $dbr->FetchRow() )
  {
    $line = 'H'.$delim;
    $txt = process_field($row['long_name'],$delim);
    $line .= $txt.$delim;
    $line = substr($line,0,-1*strlen($delim))."\n";
    $csv_output .= $line;
  }


// 2.4 output the companies.
$csv_output .= "\n";
$query = "SELECT c.*,h.long_name as hierarchy 
            FROM ".cms_db_prefix()."module_compdir_companies c
            LEFT JOIN ".cms_db_prefix()."module_compdir_hier h
              ON c.hier_id = h.id ORDER BY c.company_name";
$fquery = 'SELECT A.id,A.name,B.value 
             FROM '.cms_db_prefix().'module_compdir_fielddefs A
             LEFT JOIN '.cms_db_prefix().'module_compdir_fieldvals B
               ON A.id = B.fielddef_id
            WHERE B.company_id = ?';
$cquery = 'SELECT company_id,name 
             FROM (SELECT * FROM '.cms_db_prefix().'module_compdir_company_categories WHERE company_id = ?) AS sub 
            RIGHT JOIN '.cms_db_prefix().'module_compdir_categories AS c ON c.id = sub.category_id
            ORDER BY name ASC';

$dbresult = $db->Execute($query);
while ($dbresult && $row = $dbresult->FetchRow())
{
  // 2.1.1 output company fields.
  $line = 'C'.$delim;
  foreach( $company_fields as $fn )
    {
      $line .= process_field($row[$fn],$delim).$delim;
    }

  // 2.1.2 now output this companies fields.
  $tmp1 = $db->GetArray($fquery,array($row['id']));
  $tmp2 = cge_array::to_hash( $tmp1, 'name' );
  foreach( $fielddefs as $one_def )
    {
      $name = $one_def['name'];
      $val = '';
      if( isset($tmp2[$name]) )
	{
	  $val = $tmp2[$name]['value'];
	}
      $line .= process_field($val,$delim).$delim;
    }
  
  // 2.1.3 now output this companies categories
  $tmp = $db->GetArray($cquery,array($row['id']));
  foreach( $tmp as $one )
    {
      $val = 0;
      if( $one['company_id'] > 0 )
	$val = 1;
      $line .= $val.$delim;
    }
  
  $line = substr($line,0,-1*strlen($delim))."\n";
  $csv_output .= $line;
}


//Hack to make sure all of the CMS buffers are off
audit('',$this->GetName(),'Exported company data to csv');
$handlers = ob_list_handlers(); 
for ($cnt = 0; $cnt < sizeof($handlers); $cnt++) { ob_end_clean(); }

//Then force the output normally and exit so we don't get a footer
header("Content-disposition: attachment; filename=company_directory." . date("Y-m-d") . ".csv");
header("Content-type: text/csv");
print $csv_output;

exit;

?>