<?php  /* -*- Mode: PHP; tab-width: 4; c-basic-offset: 2 -*- */
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CompanyDirectory (c) 2004-6 by Ted Kulp (ted@cmsmadesimple.org)
#  
#  Copyright 2006,2008,2009,2010 by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to allow management of and various ways to display
#  company information for use in directories etc.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005-2010 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if (!isset($gCms)) exit;

#
# Initialization
#
$inline = 0;
$resultpage = $returnid;
$thetemplate = $this->GetPreference(COMPANYDIR_PREF_DFLTSEARCHFORM_TEMPLATE);

#
# Get parameters
#
if( isset($params['inline']) && $params['inline'] != 0 )
  {
    $inline = 1;
    unset($params['inline']);
  }
if( isset($params['resultpage']) )
  {
    $tmp = $this->resolve_alias_or_id($params['resultpage']);
    if( $tmp )
      {
	$resultpage = $tmp;
	$inline = 0;
      }
    unset($params['resultpage']);
  }
if( isset($params['searchformtemplate']) )
  {
    $thetemplate = trim($params['searchformtemplate']);
    unset($params['searchformtemplate']);
  }

#
# Give everything to smarty
#
$query = 'SELECT id,long_name FROM '.cms_db_prefix().'module_compdir_hier ORDER by hierarchy';
$tmp = $db->GetArray($query);
if( is_array($tmp) )
  {
	$tmp2 = array();
	$tmp2[''] = $this->Lang('any');
	for( $i = 0; $i < count($tmp); $i++ )
	  {
		$tmp2[$tmp[$i]['long_name']] = $tmp[$i]['long_name'];
	  }
	$smarty->assign('hierarchies',$tmp2);
  }
$tmp = $this->GetCategories();
if( is_array($tmp) )
  {
    $categories = array();
    foreach( $tmp as $one )
      {
		$categories[$one->id] = $one->name;
      }
	asort($categories);
    $smarty->assign('categories',$categories);
  }

$params['cd_origpage'] = $returnid;
$smarty->assign('formstart',
		$this->CGCreateFormStart($id,'do_search',$resultpage,$params,$inline));
$smarty->assign('formend',$this->CreateFormEnd());
$smarty->assign('input_country',$this->CreateInputCountryDropdown($id,'cd_country'));

#
# Process the template
#
echo $this->ProcessTemplateFromDatabase('searchform_'.$thetemplate);


#
# EOF
#
?>