{* new search template *}
  misc parameters:
  {$actionid}cd_resultpage - (string/integer) page id for summary results (see the help for this parameter)
  {$actionid}cd_summarytemplate - (string) see the help for this parameter
  {$actionid}cd_detailpage - (string/integer) page id for detail results (see the help for this parameter)
  {$actionid}cd_detailtemplate - (string/integer) page id for detail results (see the help for this parameter)
  
  valid fields are:
  {$actionid}cd_submit - (string) for a submit button
  {$actionid}cd_lat - (float) - specify a latitude for a radius search
  {$actionid}cd_long - (float) - specify a longitude for a radius search
  {$actionid}cd_address - (string) for an address
     (default = EMPTY)
  {$actionid}cd_radius - (int) for a distance search (valid only for postcode or lat/long searches))   
     (default = 50)
  {$actionid}cd_units  - (string) for a distance search (valid only for postcode or lat/long searches) ("km" or "miles")
     (default = miles)
  {$actionid}cd_name   - (string) for a company name
     (default = EMPTY)
  {$actionid}cd_name_type - (string) controls how the name is used ("exact" or "like")
     (default = exact)
  {$actionid}cd_address_type - (string) controls how the address field is used ("substr" or "lookup")
     (default = substr)
  {$actionid}cd_category[] - (array of integers), or comma separated list of integers, to filter on categories.  Use the {$categories} array to build checkboxes.
     (default = EMPTY)
  {$actionid}cd_hier   - (int) to specify a hierarchy id that results must belong in.
  {$actionid}cd_hier_children - (int) specify a non zero value to indicate that child hierarchies should be included in the search.
{$actionid}cd_field_expr[] - array of custom field expressions, each element should be an array of three more elements indicating the field name, the filter value, and an (optional) expression type. i.e:
  {$actionid}cd_sortby - (string) see the help for this parameter
  {$actionid}cd_sortorder - (string) see the help for this parameter

  Postal Code Searches
  ---------------------
  Notes:  If a postal/zip code is specified, and the Postcode module, and CGGoogleMaps modules are installed, then the potal/zip code will be used first to calculate a geographic search area.
  {$actionid}cd_postal  - (string) for a postal code (valid only if the Postcodes module is installed) 
     (default = EMPTY)
  {$actionid}cd_postalchars  - (integer) for a postal code (valid only if the Postcodes module is installed) 
     Used to specify the number of accurate characters that can be used to do a postal code -> lat long lookup.
     Some postal code databases are only accurate to the first N characters.
    (default = 0 == use all chars of supplied postal code)
  {$actionid}cd_country - (string) for a postal code (valid only if the Postcodes module is installed) (use two letter country code)
     (default = US)
  {$actionid}cd_searchaddress - (int) to specify that, when doing a postal code search that the address field should be searched as well.
     (default 0)   
*}

{* use some jquery, and browser location information to fill the lat/long fields
    this is great for mobile sites *}
<script type="text/javascript">{literal}//<![CDATA[
if( typeof(jQuery) != 'undefined' ){
  if(navigator.geolocation) {
    navigator.geolocation.getCurrentPosition(function(position){
      // Try W3C Geolocation (Preferred)
      $('#latitude').val(position.coords.latitude);
      $('#longitude').val(position.coords.longitude);
    });
  }
}
//]]>
{/literal}</script>

{strip}
<div id="cd_searchform">{$formstart}
  {* display any errors *}
  {if isset($errors)}
  <p class="errors">
    {'<br/>'|implode:$errors}
  </p>
  {/if}

  {* name substring search *}
  <div class="row">
    <p class="col30">{$mod->Lang('name')}</p>
    <p class="col70">
      <input type="text" name="{$actionid}cd_name" size="40"/>
      <input type="hidden" name="{$actionid}cd_name_type" value="LIKE"/>
    </p>
  </div>

  {* address substring search *}
  <div class="row">
    <p class="col30">{$mod->Lang('address')}</p>
    <p class="col70">
      <input type="text" name="{$actionid}cd_address" size="40"/>
    </p>
  </div>

  {* for lat/long radius searches *}
  <div class="row">
    <p class="col30">{$mod->Lang('coordinates')}</p>
    <p class="col70">
      {* note, if values are supplied for latitude and longitude then postal code is ignored *}
      {$mod->Lang('latitude')}: <input type="text" name="{$actionid}cd_lat" size="10" maxlength="10"/><br/>
      {$mod->Lang('longitude')}: <input type="text" name="{$actionid}cd_long" size="10" maxlength="10"/><br/>
    </p>
  </div>

  {* for postal code radius searches *}
  <div class="row">
    <p class="col30">{$mod->Lang('postal_code')}</p>
    <p class="col70">
      <input type="text" name="{$actionid}cd_postal" size="20" maxlength="20"/>
      {* you could also use the {$input_country} variable to display a country dropdown *}
      <input type="hidden" name="{$actionid}cd_country" value="CA"/>
      <input type="hidden" name="{$actionid}cd_postalchars" value="3"/>
      <input type="hidden" name="{$actionid}cd_searchaddress" value="1"/>
    </p>
  </div>

  {* for all radius searches *}
  <div class="row">
    <p class="col30">{$mod->Lang('radius')}</p>
    <p class="col70">
      <select name="{$actionid}cd_radius">
        <option value="10">10</option>
        <option value="25">25</option>
        <option value="50">50</option>
        <option value="100">100</option>
      </select>
      <input type="hidden" name="{$actionid}cd_units" value="miles"/>
    </p>
  </div>

 {* advanced filtering on hierarchies *}
 {if isset($hierarchies)}
 <div class="row">
   <p class="col30">{$mod->Lang('hierarchy')}:</p>
   <p class="col70">
     <select name="{$actionid}cd_hier">
       {html_options options=$hierarchies}
     </select>
     &nbsp;
     {$mod->Lang('label_includechildren')}:&nbsp;
     <input type="hidden" name="{$actionid}cd_hier_children" value="0"/> 
     <input type="checkbox" name="{$actionid}cd_hier_children" value="1"/>
   </p>
 </div>
 {/if}

 {* advanced filtering on categories *}
 {if isset($categories)}
 <div class="row">
   <p class="col30">{$mod->Lang('categories')}:</p>
   <p class="col70">
    {capture assign='tmp'}{$actionid}cd_use_categories{/capture}
    {html_checkboxes name=$tmp options=$categories separator='<br/>'}
  </p>
 </div>
 {/if}

 {* advanced filtering on a specific custom field*}
 <div class="row">
   <p class="col30">MyField substring Test:</p>
   <p class="col70">
     <input type="hidden" name="{$actionid}cd_field[0]['fldname']" value="myfield"/>{* hidden input for custom field name *}
     <input type="text" name="{$actionid}cd_field[0]['fldvalue']" value=""/ size="10">{* text input for custom field value *}
     <input type="hidden" name="{$actionid}cd_field[0]['expr']" value="LIKE"/>{* hidden input for custom field expression *}
   </p>
 </div>
 <div class="row">
   <p class="col30">Custom Field value test:</p>
   <p class="col70">
     <input type="hidden" name="{$actionid}cd_field[0]['fldname']" value="myintfield"/>{* hidden input for custom field name *}
     <input type="text" name="{$actionid}cd_field[0]['fldvalue']" value=""/ size="3">{* text input for custom field value *}
     <input type="hidden" name="{$actionid}cd_field[0]['expr']" value="lt"/>{* hidden input for custom field expression *}
   </p>
 </div>

{$formend}</div>{* #cd_searchform *}
{/strip}